{******************************************************************************}
{  Common routines for LocalPinger                                             }
{          M.Kochiashvili                May, 2003                             }
{                                                                              }
{******************************************************************************}
unit Common; interface
uses SysUtils, Classes;


const
  CommentChar = '#';
  
const
  HostsFileName = 'hosts.txt';
  LogFileName   = 'logs.log';

procedure ReadHosts( SL : TStrings);
procedure WriteHosts( SL : TStrings);
{ select acual host list from Source host list. Returns number of actual hosts}
function  ActualHosts( SourceSL, DestSL : TStrings) : integer;

type
  TLPingerSettings = record
    ProcessInterval : integer;
    ReceiveTimeout : integer;
    PingsToHost : integer;
    end;
procedure ReadSettings( LPS : TLPingerSettings);
procedure WriteSettings( LPS : TLPingerSettings);

implementation


procedure ReadHosts( SL : TStrings);
var TmpSL : TStringList;
begin
  if NOT FileExists( HostsFileName) then begin
    TmpSL := TStringList.Create;
    try
      TmpSL.Add('# Host list for LocalPinger');
      TmpSL.Add('127.0.0.1');
      TmpSL.Add('www.google.com');
      WriteHosts( TmpSL);
    finally
      TmpSL.Free;
      end;
    end;
  SL.LoadFromFile( HostsFileName);
end;

procedure WriteHosts( SL : TStrings);
var FS : TFileStream;
begin
  FS := TFileStream.Create( HostsFileName, fmCreate, fmShareExclusive);
  try
    SL.SaveToStream( FS);
  finally FS.Free; end;
end;

function  ActualHosts( SourceSL, DestSL : TStrings) : integer;
var Cou : integer; S : string;
begin
  DestSL.Clear;
  for Cou := 0 to SourceSL.Count - 1 do begin
    S := Trim( SourceSL.Strings[ Cou]);
    if S <> '' then
      if S[1] <> CommentChar then begin
        DestSL.Add( S);
        end;
    end;
  Result := DestSL.Count;
end;

procedure ReadSettings( LPS : TLPingerSettings);
begin
end;

procedure WriteSettings( LPS : TLPingerSettings);
begin
end;

end.
