unit LPLogViewU;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, IdBaseComponent, IdComponent,
  IdRawBase, IdRawClient, IdIcmpClient, Spin;

type
  TLPLogViewF = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    ClearBB: TBitBtn;
    LogLB: TListBox;
    MaxLinesSE: TSpinEdit;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ClearBBClick(Sender: TObject);
  private
    FFirstLine : boolean;
  public
    procedure ClearLogs;
    procedure ShowLogs( const ReplyStatus: TReplyStatus);
  end;

var
  LPLogViewF: TLPLogViewF;

implementation

{$R *.dfm}

procedure TLPLogViewF.ClearLogs;
begin
  LogLB.Items.Clear;
  FFirstLine := true;
end;

procedure TLPLogViewF.FormCreate(Sender: TObject);
begin
  FFirstLine := true;
end;

procedure TLPLogViewF.FormDestroy(Sender: TObject);
begin
{}
end;

procedure TLPLogViewF.ShowLogs(const ReplyStatus: TReplyStatus);
var S, DT : string;
begin
  while LogLB.Items.Count > MaxLinesSE.Value do LogLB.Items.Delete(0);
  with ReplyStatus do begin
    DT := DateTimeToStr( Now);
    S := Format( '%18s %17s %5d ms  %2d RStatus',
                 [DT, FromIpAddress, MsRoundTripTime, ord( ReplyStatusType)]);
    end;
  LogLB.Items.Add( S);
  Application.ProcessMessages;
end;

procedure TLPLogViewF.ClearBBClick(Sender: TObject);
begin
  ClearLogs;
end;

end.
