unit LPingGraphU;

interface

uses
  Common, MkPinger,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, TeEngine, Series, TeeProcs, Chart;

type
  TLPingGraphF = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    BitBtn1: TBitBtn;
    HostsLB: TListBox;
    PingC: TChart;
    AvgCS: TAreaSeries;
    PkLossCS: TBarSeries;
    MaxCS: TLineSeries;
    MinCS: TLineSeries;
    LegendCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure HostsLBClick(Sender: TObject);
    procedure LegendCBClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  LPingGraphF: TLPingGraphF;

implementation
{$R *.dfm}

function ReadLogToSeries( FN : string;
                          CSMin, CSAvg, CSMax, CSPkLoss : TChartSeries) : integer;
var SL : TStringList; Cou : integer; PS : TPingerStat;
begin
  Result := 0;
  SL := TStringList.Create;
  if Assigned( CSMin) then CSMin.Clear;
  if Assigned( CSAvg) then CSAvg.Clear;
  if Assigned( CSMax) then CSMax.Clear;
  if Assigned( CSPkLoss) then CSPkLoss.Clear;
  try
    SL.LoadFromFile( FN);
    if SL.Count <= 0 then Abort;
    Result := SL.Count;
    for Cou := 0 to SL.Count - 1 do begin
      try
        ParseLogString( SL.Strings[ Cou], PS);
        with PS do begin
          if Assigned( CSMin) then CSMin.AddXY( DateTime, RttMin, '', clTeeColor);
          if Assigned( CSAvg) then CSAvg.AddXY( DateTime, RttAvg, '', clTeeColor);
          if Assigned( CSMax) then CSMax.AddXY( DateTime, RttMax, '', clTeeColor);
          if Assigned( CSPkLoss) then CSPkLoss.AddXY( DateTime, PkLossPrc, '', clTeeColor);
          end;
      except { don't do anything} end;
      end;
  finally
    SL.Free;
    end;
end;

procedure TLPingGraphF.FormCreate(Sender: TObject);
begin
  if GetLogHostsList( HostsLB.Items) >= 0 then begin
    HostsLB.ItemIndex := 0;
    HostsLBClick( Self);
    end;
end;

procedure TLPingGraphF.HostsLBClick(Sender: TObject);
var HostN : string;
begin
  if HostsLB.ItemIndex < 0 then exit;
  HostN := HostsLB.Items.Strings[ HostsLB.ItemIndex];
  PingC.Title.Text.Text := HostN;
  ReadLogToSeries( LogsSubdir + HostToFileName( HostN), MinCS, AvgCS, MaxCS, PkLossCS);
  if MaxCS.MaxYValue > 0 then
    PkLossCS.YValues.Multiplier := MaxCS.MaxYValue / 100;
end;

procedure TLPingGraphF.LegendCBClick(Sender: TObject);
begin
  PingC.Legend.Visible := LegendCB.Checked;
end;

end.
